/*
 *  FILE    : LoginPanel.java
 *  Ver     : 1.0      (Dec., `99)
 *  AUHTHOR : Sangyoon Oh
 *            soh@napc.syr.edu
 *
 */


import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.border.*;
import java.util.*;
import java.io.*;
import org.w3c.dom.*;
import org.xml.sax.*;
import com.ibm.xml.parsers.DOMParser;

public class StatusPanel extends JPanel {

    //ctor
    public StatusPanel(MainPanel _mp) {
        mp = _mp;
            
        // request button
        requestButton.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                
                cName = (String)table.getValueAt(table.getSelectedRow(),0);
                
                if(mp.parent.dm.getValue("community", cName, "status").compareTo("none")==0) {
                    adminName = mp.parent.dm.getValue("user", mp.parent._userName, "name"); 
                    adminEmail = mp.parent.dm.getValue("user", mp.parent._userName, "e-mail"); 
                    communityAddress = mp.parent.dm.getValue("community", cName, "e-mail");
                
                    // set new password
                    /**
                    pDialog = new PasswdDialog(mp.parent);
                    pDialog.setVisible(true);
                    
                    if(pDialog.getValid()) {
                    pDialog.dispose();
                    **/
                        
                    setUpMail();            
                    
                    // configration of proper sentance to request majordomo list
                    //
                    tm.setContext("Majordomo creation request of : " + cName 
                                + "\nfrom " + adminName + "<" + adminEmail + ">" );
                    try {
                        tm.sendMail();
                    }
                    catch(MailException me) {}
                    try {
                        mp.parent.dm.setValue("community", cName, "status", "requested"); 
                        mp.parent.dm.update();
                    }
                    catch(Exception ee) {}
                    JOptionPane.showMessageDialog( mp.parent.frame, "Creation of majordomo is requested!!"
                        , "Creation Request", JOptionPane.INFORMATION_MESSAGE );
                    table.setValueAt("requested", table.getSelectedRow(), 1);
                }
                /**
                else {
                    JOptionPane.showMessageDialog( mp.parent.frame, "majordomo is already requested or granted!!"
                                , "Request error", JOptionPane.ERROR_MESSAGE );
                }
                **/
            }
        });
        
        // set button
        setButton.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                cName = (String)table.getValueAt(table.getSelectedRow(),0);
                
                if(mp.parent.dm.getValue("community", cName, "status").compareTo("requested")==0) {
                    try {
                        mp.parent.dm.setValue("community", cName, "status", "granted"); 
                        mp.parent.dm.update();
                    }
                    catch(Exception eee) {}
                    table.setValueAt("granted", table.getSelectedRow(), 1);
                }
                else {
                    JOptionPane.showMessageDialog( mp.parent.frame, "majordomo is not requested or is granted!!"
                                , "Grant error", JOptionPane.ERROR_MESSAGE );
                }
            }
        });
        
        
        // table
        // definition of table header         
        Vector columnNames = new Vector();            
        columnNames.addElement("Majordomo List");
        columnNames.addElement("Status");
        table = new JTable(model = new CommunityTableModel(data, columnNames));        
        table.setPreferredScrollableViewportSize(new Dimension(250,150));
        
        // scroll panel
        JScrollPane sp = new JScrollPane(table);
        JPanel tablePanel = new JPanel(new BorderLayout());
        tablePanel.setBorder(new EmptyBorder(5, 5, 0, 5)); 
        tablePanel.add(sp, BorderLayout.CENTER);
        
        // button panel
        JPanel buttonPanel = new JPanel(new FlowLayout(FlowLayout.RIGHT));
        buttonPanel.add(requestButton);
        buttonPanel.add(setButton);
        
        // gui
        setLayout(new BorderLayout());
        add(tablePanel, BorderLayout.CENTER);
        add(buttonPanel, BorderLayout.SOUTH);
        
        Enumeration ee = mp.parent.dm.getObjects("community");
        
        while( ee.hasMoreElements() ) {
            String commName = ee.nextElement().toString();
            if(commName.compareTo("system_manager")!=0) {
                String status = mp.parent.dm.getValue("community", commName, "status");
                model.addRow(new Community(commName, status));
            }
        }
    }
    
    // set up mail parameters
    public void setUpMail() {
        try {
            StringTokenizer st = new StringTokenizer(communityAddress, "@");
            st.nextToken();
            tm = new TangoMail(st.nextToken());
            System.out.println("TM established");
            tm.setSubject("");
            tm.setFrom("", adminEmail);
            v.removeAllElements();
            h.put("toname", cName);
            h.put("toadr", communityAddress);
            v.addElement(h);
            tm.addTo(v);
        }
        catch(Exception e1) {}
    }
    
    protected MainPanel mp;
    
    protected Vector data = new Vector();
    protected JTable table;
    protected JButton requestButton = new JButton("Request");
    protected JButton setButton = new JButton("Grant");    
    protected CommunityTableModel model;
    
    protected TangoMail tm; 
    protected PasswdDialog pDialog;
    protected String communityAddress, cName, adminEmail, adminName;
    protected Vector v = new Vector(); 
    protected Hashtable h = new Hashtable();
}
